#include "KinectDevice.h"


KinectDevice::KinectDevice(void)
{
	m_pNuiSensor = NULL;
	m_hDepth = m_hDepthEvent = m_hSkeletonEvent = m_hVideo = m_hVideoEvent = NULL;
}

KinectDevice::~KinectDevice(void)
{
	// KinectVbg_E
	NuiShutdown();
}

// KinectoA鏈
INuiSensor* KinectDevice::initKinect()
{
	INuiSensor * pNuiSensor = NULL;

	// ܂Kinect̑䐔擾
	int iSensorCount = 0;
	HRESULT hr = NuiGetSensorCount(&iSensorCount);
	if(FAILED(hr)) {
		return NULL;
	}

	// 䐔1ڂLɂł̂TĂ
	for(int i = 0; i < iSensorCount; ++i) {
		// LɂłȂ玟̂`FbNɂ
		hr = NuiCreateSensorByIndex(i, &pNuiSensor);
		if(FAILED(hr)) {
			continue;
		}

		// RlNgłĂ烋[v𔲂ďs
		hr = pNuiSensor->NuiStatus();
		if(S_OK == hr) {
			break;
		}

		// _Ď̂ɓq
		pNuiSensor->Release();
	}

	// [v𔲂_ŗLɂȂ̂Ώs
	if(NULL != pNuiSensor) {
		// Kinect̋@\̂ALɂ邩w肵ďs
		hr = pNuiSensor->NuiInitialize(NUI_INITIALIZE_FLAG_USES_DEPTH_AND_PLAYER_INDEX 
			| NUI_INITIALIZE_FLAG_USES_SKELETON | NUI_INITIALIZE_FLAG_USES_COLOR); 
		if(SUCCEEDED(hr)) {
			// XPg擾@\L
			m_hSkeletonEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
			hr = pNuiSensor->NuiSkeletonTrackingEnable(m_hSkeletonEvent, 0); 
			if(FAILED(hr)) {
				fl_alert("failed1");
				pNuiSensor->Release();
				return NULL;
			}

			// J[fL
			m_hVideoEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
			// 𑜓x320x240640x480I
			hr = pNuiSensor->NuiImageStreamOpen( NUI_IMAGE_TYPE_COLOR,
				NUI_IMAGE_RESOLUTION_640x480, 0, 2, m_hVideoEvent, &m_hVideo);
			if(FAILED(hr)) {
				fl_alert("failed2");
				pNuiSensor->Release();
				return NULL;
			}

			// fvXfL
			m_hDepthEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
			hr = NuiImageStreamOpen(NUI_IMAGE_TYPE_DEPTH_AND_PLAYER_INDEX,
				NUI_IMAGE_RESOLUTION_320x240, 0, 2, m_hDepthEvent, &m_hDepth);
			if(FAILED(hr)) {
				fl_alert("failed3");
				pNuiSensor->Release();
				return NULL;
			}
		}
	}

	// ̎_ŃZT[NULLA邢͗LɎsĂAEg
	if(NULL == pNuiSensor || FAILED(hr)) {
		fl_alert("No ready Kinect found!");
		if(pNuiSensor != NULL) {
			pNuiSensor->Release();
		}
		return NULL;
	}

	// oϐɋL
	m_pNuiSensor = pNuiSensor;

	return pNuiSensor;
}

// J[Qbg
void KinectDevice::procVideo(fkut_SpriteModel &kinectVideo)
{
	// VOi`FbN(rfI̍XVɏ)
	if(WAIT_OBJECT_0 == WaitForSingleObject(m_hVideoEvent, 0)) {
		const NUI_IMAGE_FRAME * pImageFrame = NULL;
		if(FAILED(NuiImageStreamGetNextFrame(m_hVideo, 0, &pImageFrame))) {
			cout << "video error!" << endl;
		}
	
		int wid	= 640, hgt = 480;
		BYTE *buf = (BYTE*)kinectVideo.getImage()->getBufPointer();

		// 摜f[^擾
		INuiFrameTexture * pTexture = pImageFrame->pFrameTexture;
		NUI_LOCKED_RECT LockedRect;
		pTexture->LockRect(0, &LockedRect, NULL, 0);
		if(LockedRect.Pitch != 0) {
			BYTE * pBuffer = (BYTE*) LockedRect.pBits;

			// fk_Imagẽobt@TCY2ׂ̂ɂȂĂ_ɒӁI
			for(int y = 0; y < hgt; y++){
				for(int x = 0; x < wid; x++){
					// ㉺]Ă̂ŕ␳
					buf[(x + y * 1024) * 4+2] = pBuffer[(x + (hgt-y-1) * wid) * 4+0];
					buf[(x + y * 1024) * 4+1] = pBuffer[(x + (hgt-y-1) * wid) * 4+1];
					buf[(x + y * 1024) * 4+0] = pBuffer[(x + (hgt-y-1) * wid) * 4+2];
					buf[(x + y * 1024) * 4+3] = 255;
				}
			}
		}
		pTexture->UnlockRect(0);
		NuiImageStreamReleaseFrame(m_hVideo, pImageFrame);
		kinectVideo.getImage()->SetUpdateArea();
	}
	return;
}

// F1ɂ܂Ƃ߂\
struct PackedColor {
	unsigned char B;
	unsigned char G;
	unsigned char R;
	unsigned char A;
};
// ܂Ƃߊ֐
static PackedColor PackColor(unsigned char R, unsigned char G, unsigned char B, unsigned char A)
{
	PackedColor c = { B, G, R, A };
	return c;
}
// [xlPxlւ̕ϊ֐
PackedColor convertDepthToColor(USHORT s)
{
	USHORT RealDepth = (s & 0xfff8) >> 3;
	USHORT Player = s & 7;
	// transform 13-bit depth information into an 8-bit intensity appropriate
	// for display (we disregard information in most significant bit)
	BYTE d = 255 - (BYTE)(256*RealDepth/0x0fff);
  
	switch( Player ) {
	case 0:
		return PackColor(d/2, d/2, d/2, 255);
	case 1:
 		return PackColor(  0,   0,   d, 255);
	case 2:
		return PackColor(  0,   d,   0, 255);
	case 3:
		return PackColor(  d,   d, d/4, 255);
	case 4:
		return PackColor(d/4,   d,   d, 255);
	case 5:
		return PackColor(  d, d/4,   d, 255);
	case 6:
		return PackColor(  d, d/2, d/2, 255);
	case 7:
		return PackColor(255-(d/2), 255-(d/2), 255-(d/2), 255);
	}
	return PackColor(0, 0, 0, 255);
}

// fvXQbg
void KinectDevice::procDepth(fkut_SpriteModel &kinectDepth)
{
	// VOi`FbN(fvX̍XVɏ)
	if(WAIT_OBJECT_0 == WaitForSingleObject(m_hDepthEvent, 0)) {
		const NUI_IMAGE_FRAME * pImageFrame = NULL;
		if(FAILED(NuiImageStreamGetNextFrame(m_hDepth, 0, &pImageFrame))){
			cout << "error" << endl;
		}
	
		int wid	= 320, hgt = 240;
		PackedColor *buf = (PackedColor*)kinectDepth.getImage()->getBufPointer();

		// fvXl擾Fɕϊ
		INuiFrameTexture * pTexture = pImageFrame->pFrameTexture;
		NUI_LOCKED_RECT LockedRect;
		pTexture->LockRect(0, &LockedRect, NULL, 0);
		if(LockedRect.Pitch != 0) {
			BYTE * pBuffer = (BYTE*) LockedRect.pBits;
			USHORT * pBufferRun = (USHORT*) pBuffer;
			for(int y = 0; y < hgt; y++){
				for(int x = 0; x < wid; x++) {
					// ϊ֐ł́AvC[ƂɐFt[xlPxlɂĂ
					// ㉺]̓J[摜Ɠl
					buf[(x + (hgt-y-1) * 512)] = convertDepthToColor(*pBufferRun);
					pBufferRun++;     
				}
			}
		}
		pTexture->UnlockRect(0);
		NuiImageStreamReleaseFrame(m_hDepth, pImageFrame);
		kinectDepth.getImage()->SetUpdateArea();
	}
	return;
}

// XPgQbg
void KinectDevice::procSkeleton(fkut_SphereModel *sph)
{
	// VOi`FbN(XPg̍XVɏ)
	if(WAIT_OBJECT_0 == WaitForSingleObject(m_hSkeletonEvent, 0)) {
		NUI_SKELETON_FRAME SkeletonFrame;
		HRESULT hr = NuiSkeletonGetNextFrame( 0, &SkeletonFrame );

		bool bFoundSkeleton = true;
		for( int i = 0 ; i < NUI_SKELETON_COUNT ; i++ ) {
			if( SkeletonFrame.SkeletonData[i].eTrackingState == NUI_SKELETON_TRACKED ){
				bFoundSkeleton = false;
			}
		}

		// smooth out the skeleton data
		NuiTransformSmooth(&SkeletonFrame,NULL);

		// draw each skeleton color according to the slot within they are found.
		bool	bBlank = true;
		Vector4	pos;
		// LONG	fx = 0, fy = 0;
		// USHORT	depth;
		for(int i = 0 ; i < NUI_SKELETON_COUNT; i++){
			pos = SkeletonFrame.SkeletonData[i].Position;
			if(SkeletonFrame.SkeletonData[i].eTrackingState == NUI_SKELETON_TRACKED){
				bBlank = false;
				for(int j = 0; j < 20; ++j) {
					pos = SkeletonFrame.SkeletonData[i].SkeletonPositions[j];
					// XP[ƃItZbg𒲐Ă̂ŁA͗prɉĕύX
					sph[j].glMoveTo(pos.x*20.0, pos.y*20.0, pos.z*20.0);

					// fvX摜̍Wnɕϊꍇ͂̊֐g
					// NuiTransformSkeletonToDepthImage(pos, &fx, &fy, &depth);
					// sph[j].glMoveTo((double)fx/8.0, (double)-fy/6.0 + 40.0, 0.0);
				}
			}
		}
	}
	return;
}
