#include "FKUT/FKUT.h"
#include "KinectDevice.h"

int main(int argc, char *argv[])
{
	KinectDevice	kinect;
	// Kinect
	INuiSensor*	pNuiSensor = kinect.initKinect();
	if(pNuiSensor == NULL) {
		fl_alert("Kinect not found!");
		return -1;
	}

	fkut_SimpleWindow	window;

	window.setSize(960, 544);			// EBhȆ傫͂D݂
	window.setBGColor(0.3, 0.6, 0.8);	// wiFR, G, B̐F0.0`1.0Ńuhč
	window.setTrackBallMode(true);
	window.setGuideNum(100);
	window.showGuide();
	window.open();						// EBhÊ\

	// 摜Qbgp
	fkut_SpriteModel	kinectVideo, kinectDepth;

	kinectVideo.readBMP("vga.bmp");
	kinectVideo.setScale(0.5);
	kinectVideo.glMoveTo(-320.0, 152.0, 0.0);
	window.entry(kinectVideo);

	kinectDepth.readBMP("qvga.bmp");
	kinectDepth.glMoveTo(-320.0, -152.0, 0.0);
	window.entry(kinectDepth);

	// XPgQbgp
	fkut_SphereModel	sph[20];

	for(int i = 0; i < 20; ++i) {
		sph[i].create(8, 1.0);
		sph[i].setMaterial(Red);
		window.entry(sph[i]);
	}

	while(window.update() == true) {
		// 摜擾
		kinect.procVideo(kinectVideo);
		kinect.procDepth(kinectDepth);
		// XPg擾
		kinect.procSkeleton(sph);
	}

	return 0;
}
